/****************************************************************************
indexhlp.cpp

Thu 10/25/2007 2:25 pm  creation from index_h1.cpp.

****************************************************************************/

#ifdef __GNUC__
  #define GNU_C (1)
  #if __GNUC__ >= 4
    #define stricmp strcasecmp
    #define strnicmp strncasecmp
  #endif
#endif

#define WILD (0)     //get rid of non-feature.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#if WILD
#include <dir.h>
#include <dos.h>
#endif
#if GNU_C
#include <cstdarg>
#endif
#if !GNU_C
#include <alloc.h>
#endif
#include "tla.h"
#if defined(__FLAT__)
#include <stdarg.h>
#endif

#if JUNK
#include <io.h>
#endif

#include <time.h>

#include <string>
using namespace std;  //required mumbo-jumbo.

#define YES (1)
#define NO (0)
//#define TRUE YES
//#define FALSE NO

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */


#ifndef BYTE
  #define BYTE char
#endif

typedef unsigned char UCHAR;

#ifndef sBYTE
  #define sBYTE signed char
#endif

#ifndef WORD
//  typedef unsigned int WORD;
#endif

#if GNU_C
  typedef unsigned int WORD;
#endif

#ifndef BIG
  typedef unsigned long BIG;
#endif

#define ARRAYSIZE(x) (sizeof(x) / sizeof(x[0]))

#define ENTER (13)
#define CR (13)
#define LF (10)
#define CTL (0x40)        /* 'A'-CTL is ^A. */
#define ESC (0x1b)
/* #define sESC "\33" */
#define DEL (0x5300)
#define BS (8)
#define TAB (9)

#define sCR  "\xD"
#define sLF  "\xA"
#define sDEL "\x7f"
#define sACK "\x6"
#define sESC "\x1b"
#define sBEL "\x7"

#define BIT0 (1)
#define BIT1 (2)
#define BIT2 (4)
#define BIT3 (8)
#define BIT4 (16)
#define BIT5 (32)
#define BIT6 (64)
#define BIT7 (128)
#define BIT8 (256)
#define BIT9 (512)
#define BIT10 (1024)
#define BIT11 (2048)
#define BIT12 (4096)
#define BIT13 (8192)
#define BIT14 (16384)
#define BIT15 (32768)
#define BIT16 (65536)
#define BIT17 (131072)
#define BIT18 (262144)
#define BIT19 (524288)
#define BIT20 (1048576)
#define BIT21 (2097152)
#define BIT22 (4194304)
#define BIT23 (8388608)
#define BIT24 (16777216)
#define BIT25 (33554432)
#define BIT26 (67108864)
#define BIT27 (134217728)
#define BIT28 (268435456)
#define BIT29 (536870912)
#define BIT30 (1073741824)
#define BIT31 (2147483648)

#define nBIT(x) (1 << (x))                          /*  */
/* this doesn't work with BIGs. Then it should be
  #define nBIT(x) ((BIG)(((BIG)1) << ((BIG)x)))
*/

#define lo(one,two) ( ((one) < (two)) ? (one) : (two))    /*  */
#define hi(one,two) ( ((one) > (two)) ? (one) : (two))    /* not tested. */

#define kLOW(x) ((x) & 255)
#define kHIGH(x) (((x) >> 8)&255)

/* kill annoying error messages from JGW LOW, HIGH def. */
#ifdef LOW
  #undef LOW
#endif
#ifdef HIGH
  #undef HIGH
#endif

#define LOW(x)  (((BYTE *)&(x))[0])
#define HIGH(x) (((BYTE *)&(x))[1])

/****************************************************************************
****************************************************************************/
#define BF_HTM YES   //browser/frame html.
#define BF_DIV BF_HTM //alternate indent scheme.
/****************************************************************************
****************************************************************************/
/****************************************************************************
some harmless prototypes.
****************************************************************************/
void depart(void);


int errorcount;

FILE *errout
#if !defined(__FLAT__)
=stderr
#endif
;

char *iname, *oname, *numbers_name;

FILE *ifile, *ofile, *numbers_file;

#if BF_HTM
int frame;
char *frame_rut="owen", *frame_name, *frame_index;

char *frame_title="Help";

FILE *frame_file, *frame_index_file;

#if BF_DIV
int old_indent;
#endif

#endif

int exclude_BLRS = YES;

/****************************************************************************
****************************************************************************/

/* returns -1 so functions can return it as error I guess. */
_f int erprintf(int terminal, char *format, ...) {
  va_list argptr;

  char abuf[10];

  va_start(argptr, format);
  vfprintf(errout,format,argptr);
  va_end(argptr);
  fputc('\n',errout);

  ++errorcount;

  if (terminal) {
    fprintf(errout," (press enter)");
    fgets(abuf,5,stdin); /* hope you didn't redirect */
    exit(terminal);
  }
  return -1;
}

/****************************************************************************
****************************************************************************/
int indents=YES;

#if BF_HTM
char *deblr(char *s) {
  int i;
  for (i=0; s[i]; ++i) {
    if (s[i]=='_')
    s[i] = ' ';
  }
  return s;
}

char *blrize(char *s) {
  int i;
  for (i=0; s[i]; ++i) {
    if (s[i]==' ')
    s[i] = '_';
  }
  return s;
}

_f char *lastchar(char *s) {
  if (!*s) return s;
  return s+strlen(s)-1;
}


char *dequote(char *s) {
  char *closequote;
  if (
  (s[0]=='\"')
  &&
  ( *(closequote=lastchar(s))=='\"' )
  )
  {
    *closequote = '\0';
    return s+1;
  }
  return s;
}
#endif

/****************************************************************************
****************************************************************************/
_f char *mytime(void) {
  time_t secs_now;
  struct tm *tm_now;
  WORD hour;
  static char thistime[37];
  static char *weekdays[7] = {
    "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday",
    "Saturday" };
  char *ampm;

  time(&secs_now);
  tm_now = localtime(&secs_now);
  hour = tm_now->tm_hour;
  if (tm_now->tm_hour >= 12) {
    ampm="pm";
    if (tm_now->tm_hour>12)
    hour -= 12;
  }
  else ampm="am";

  sprintf(thistime,"%s %u/%u/%02u %u:%02u %s",
  weekdays[tm_now->tm_wday],
  tm_now->tm_mon+1,
  tm_now->tm_mday,
  tm_now->tm_year % 100,
  hour,
  tm_now->tm_min,
  ampm);
  return thistime;
}

_f void mustopen(FILE **f, char *name, char *mode) {
  if (!(*f=fopen(name,mode))) {
    fprintf(stderr,"couldn't open %s for %s.",name,mode);
    exit(3);
  }
}

/****************************************************************************
****************************************************************************/
#if WILD

#if defined(__FLAT__)
void *findfinish(struct ffblk *ffblk) {
  findclose(ffblk);
  return NULL;
}
#else
#define findfinish(x) NULL
#endif

/* If name, returns first next instance of name (NULL if none). If name==NULL,
returns next (NULL if none). */

_f char *getwild(char *name) {
  static char path[MAXPATH], drive[MAXDRIVE],
  dir[MAXDIR], file[MAXFILE], ext[MAXEXT];
  static struct ffblk ffblk;
  if (name) {
    fnsplit(name,drive,dir,file,ext);
    if (findfirst(name,&ffblk,0))
    return (char *)findfinish(&ffblk);
  }
  else {
    if (findnext(&ffblk))
    return (char*)findfinish(&ffblk);
  }
  fnsplit(ffblk.ff_name,NULL, NULL,file,ext);
  fnmerge(path,drive,dir,file,ext);
  return path;
}

/* return nz if file name exists. evades append. */
_f int exist(char *name) {
  return !access(name,0);
}

#endif
/****************************************************************************
****************************************************************************/
_f char *stristr(char *target, char *what) {
  int length;
  if (length=strlen(what)) {
    while (*target) {
      if (!(strnicmp(target,what,length))) return target;
      ++target;
    }
  }
  return NULL;
}

/****************************************************************************
****************************************************************************/
/****************************************************************************
****************************************************************************/
/****************************************************************************
****************************************************************************/

/****************************************************************************
(from blog at my web site)

:::::::::::::::::::::::::::first part of frame

<html>
<head>
<title>The Owen Blogs &bull; owen_bda4@yahoo.com</title>
<link rel="SHORTCUT ICON" href="http://home.att.net/~owen_labs/favicon.ico"></head>
<frameset cols="20%,*">
  <frame src="bb_index.htm"> <frame src="owenhelp.htm" name="blog">
  <noframe>
    You were too cheap to get a browser that does frames, but what the heck
    we'll let you have some links anyway....<br>
<a href="owenhelp.htm#Introduction">Introduction</a><br>


:::::::::::::::::::::::::::last part of frame
  </noframe>
</frameset>
</html>


I hacked this one a bit already.
:::::::::::::::::::::::::::first part of index.
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>The Owen Blogathon &bull; owen_bda4@yahoo.com</title>
  <base target="blog">
<link rel="SHORTCUT ICON" href="http://home.att.net/~owen_labs/favicon.ico"></head>
<body style="background-image: url(orange.gif);">
<a href="owenhelp.htm#Introduction">Introduction</a><br>
<a href="owenhelp.htm#BSD_License">BSD License</a><br>
&nbsp;&nbsp;&nbsp;&nbsp;<a href="owenhelp.htm#The_Ini_File_is_Deleted">The Ini File is Deleted</a><br>

:::::::::::::::::::::::::::last part
</body>
</html>


:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
Ok these are the mutilated versions. Where I discovered mysterious errors I've
had in there for years.... Dolt! Those were *correct*!
:::::::::::::::::::::::::::first part of frame

----------------------------------------
<html>
<head>
<title>`%s</title>
</head>
<frameset cols="`%d%,*">
  <frame src="`%s"> <frame src="`%s" name="help">
  <noframe>
    (Your browser doesn't support frames for some reason; this is the
    no-frames version of the help index)<br>
----------------------------------------

<a href="owenhelp.htm#Introduction">Introduction</a><br>


:::::::::::::::::::::::::::last part of frame
----------------------------------------
  </noframe>
</frameset>
</html>
----------------------------------------


:::::::::::::::::::::::::::first part of index.
----------------------------------------
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>`%s</title>
  <base target="help">
</head>
<body>
----------------------------------------



<a href="owenhelp.htm#Introduction">Introduction</a><br>
<a href="owenhelp.htm#BSD_License">BSD License</a><br>
&nbsp;&nbsp;&nbsp;&nbsp;<a href="owenhelp.htm#The_Ini_File_is_Deleted">The Ini File is Deleted</a><br>

:::::::::::::::::::::::::::last part
----------------------------------------
</body>
</html>
----------------------------------------




****************************************************************************/
#if BF_HTM    //this whole section.

#define DEF_FRAME_PERCENT (35)

int frame_percent = DEF_FRAME_PERCENT;

char *frame_begin =


"<html>\n"
"<head>\n"
"<title>%s</title>\n"
"</head>\n"
"<frameset cols=\"%d%%,*\">\n"
"  <frame src=\"%s\"> <frame src=\"%s\" name=\"help\">\n"
"  <noframe>\n"
"    (Your browser doesn't support frames for some reason; this is the\n"
"    no-frames version of the help index)<br>\n"

;

char *frame_end =

"  </noframe>\n"
"</frameset>\n"
"</html>\n"

;

char *index_begin =


"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
"<html>\n"
"<head>\n"
"  <title>%s</title>\n"
"  <base target=\"help\">\n"
"</head>\n"
"<body>\n"

;

char *index_end =


"</body>\n"
"</html>\n"


;

/****************************************************************************
****************************************************************************/
/****************************************************************************
****************************************************************************/
/****************************************************************************
  <a href="`%s#`%s">`%s</a><br>
****************************************************************************/

#define FRAME_SUFFIX "frm.htm"
#define INDEX_SUFFIX "idx.htm"

void name_ify(void) {
//  string s;

  frame_name  = strdup(((string)frame_rut + FRAME_SUFFIX).c_str());
  frame_index = strdup(((string)frame_rut + INDEX_SUFFIX).c_str());
//we officially enter the 90s....

  deblr(frame_title);

}


void begin_frame(void) {
  static int frame_begun;

  if ((!frame) || frame_begun)
  return;

  frame_begun = YES;

  name_ify();

  mustopen(&frame_file,frame_name,"w");

  mustopen(&frame_index_file,frame_index,"w");

  fprintf(frame_file,frame_begin
  ,frame_title
  ,frame_percent
  ,frame_index
  ,iname
  );

  fprintf(frame_index_file,index_begin
  ,frame_title
  );

}

/****************************************************************************
123456
1000.5

****************************************************************************/
#if BF_DIV

char *em(int indent) {
  static char theem[10];

  if (indent & 1)
  sprintf(theem,"%d.5",indent/2);
  else
  sprintf(theem,"%d.0",indent/2);

  return theem;

}

#endif

/****************************************************************************



  <a href="`%s#`%s">`%s</a><br>


<div style="margin-left: 0.5em " ><a href="owenhelp.htm#Contents_versus_Index">(TEST #5 0.5em? this is right!) Contents versus Index</a><br></div>

         10        20        30        50
1234567890123456789012345678901234567890
<div style="margin-left: 0.5em " >

blah blah
</div>



****************************************************************************/
void bf_htm(char *s, int indent) {
  char *blr;

#if BF_DIV
  char bdiv[60], *ediv;
#endif

  if (!frame)
  return;

  blr = strdup(s);
  blrize(blr);
  deblr(s);

  begin_frame();

#if BF_DIV
  if (old_indent) {
#endif
//ok do an entry. First in the index.
  if (indents) {  //I forgot this until Fri 11/30/2007 12:04 pm.
    for (int i=1; i<indent; ++i) {
      fprintf(frame_index_file,"&nbsp;&nbsp;");
    }
  }

  fprintf(frame_index_file,

"<a href=\"%s#%s\">%s</a><br>\n"

  ,iname
  ,blr
  ,s
  );

//it's the same.
//ok do an entry. First in the index.
  for (int i=1; i<indent; ++i) {
    fprintf(frame_file,"&nbsp;&nbsp;");
  }

  fprintf(frame_file,



"<a href=\"%s#%s\">%s</a><br>\n"



  ,iname
  ,blr
  ,s
  );

#if BF_DIV
  }             //if (old_indents)

  else {
    if (indents) {
      if (--indent < 1) {
        bdiv[0]='\0';
        ediv="";
      }
      else {
        sprintf(bdiv,"<div style=\"margin-left: %sem\">",
        em(indent)
        );
        ediv="</div>";
      }
    }
    else {
      bdiv[0]='\0';
      ediv="";
    }

    fprintf(frame_index_file,

    "%s<a href=\"%s#%s\">%s</a><br>%s\n"
    ,bdiv
    ,iname
    ,blr
    ,s
    ,ediv
    );

  //it's the same.
  //ok do an entry. First in the index.

    fprintf(frame_file,
    "%s<a href=\"%s#%s\">%s</a><br>%s\n"
    ,bdiv
    ,iname
    ,blr
    ,s
    ,ediv
    );

  }

#endif



  free(blr);


}


/****************************************************************************
****************************************************************************/

void end_frame(void) {
  static int frame_ended;

  if ((!frame) || frame_ended)
  return;

  frame_ended = YES;

  fprintf(frame_index_file,"%s",index_end);

  fprintf(frame_file,"%s",frame_end);

  fclose(frame_index_file);

  fclose(frame_file);

}



#endif    //if BF_HTM.
/****************************************************************************
****************************************************************************/
/****************************************************************************
****************************************************************************/

/****************************************************************************
getcharacter from ifile, send it to ofile. // but in this indexhlp version,
*don't* send it to an output file.
****************************************************************************/

#if 0
int getxfer(void) {
  int c;
  static int wasLF;

  NASTYLABEL:

  c=getc(ifile);

  wasLF |= (c==LF);

  if (c==CR) {
    if (
    (wasLF) && (remove2now)
    ) {
      changed = YES;
      getc(ifile);        /* throw away the LF. */
      goto NASTYLABEL;    /* I just love it when I do that. */
    }
#if FIXLINES3
    CRtell=ftell(xfero);
#endif
  }

  if (c>=' ')
  wasLF = NO;


//  if (c!=EOF)
//  fputc(c,xfero);

  ++ccount;

  if (c==LF)
  ccount = 0;   /* this was supposed to fix the double-line problem.*/

  return c;
}
#endif

int getxfer(void) {
  return getc(ifile);
}

/****************************************************************************
<H1><a name="Main Screen">
****************************************************************************/

#define BSIZE (200)
char abuffo[BSIZE+5];

int anyanchor;


typedef enum {
  NOTHING=0,
  H1,
  H2,
  H3,
  xH1,
  xH2,
  xH3,
  ANCHOR,    /* <A */
  GRAF,
  CLOSE_GRAF,
  BREAK,
  OTHER_ANGLE
} THINGTYPE;

int ismypunk(int c) {
  return
  ispunct(c) &&
  (!strchr("!-#",c));
}


THINGTYPE getthing(void) {
  int c, index;
  char *p;

  while (1) {
    LOOPANYWAY:   /* truly evil. */

    c = getxfer();

    if (
    (c==' ') || (c==TAB)
    )

    continue;

    switch (c) {
      case EOF:
      return NOTHING;

      case '>':
      goto LOOPANYWAY;

      case '<':
      p=abuffo;
      abuffo[0]='<';
      abuffo[1]='\0';
      while(1) {
        if ( (p-abuffo) > BSIZE)
        goto LOOPANYWAY;

        ++p;

        *p=getxfer();
        p[1]='\0';
        if (*p=='>') {    //figger out what it is.

          if (strnicmp(abuffo,"<A",2)==0)
          return ANCHOR;

          if (strnicmp(abuffo,"<H1",3)==0)
          return H1;

          if (strnicmp(abuffo,"<H2",3)==0)
          return H2;

          if (strnicmp(abuffo,"<H3",3)==0)
          return H3;

          if (strnicmp(abuffo,"</H1",4)==0)
          return xH1;

          if (strnicmp(abuffo,"</H2",4)==0)
          return xH2;

          if (strnicmp(abuffo,"</H3",4)==0)
          return xH3;

          if (stricmp(abuffo,"<p>")==0)
          return GRAF;

          if (stricmp(abuffo,"</p>")==0)
          return CLOSE_GRAF;

          if (stricmp(abuffo,"<br>")==0)
          return BREAK;



          return OTHER_ANGLE;

        }
      }
    }
  }
}

/****************************************************************************
Introduction=1;
Main Screen=2;
Menus=3;
Exit=4;
Load=5;
Effects=6;
Edit=7;
Edit: Cut=8;
****************************************************************************/
void numbers(char *s) {

  static char b[BSIZE];
  char *p, *eq;
  int found=NO;


  if (!numbers_file)
  return;

  rewind(numbers_file);

  while (p=fgets(b,BSIZE,numbers_file)) {
    if (b[0]==';')
    continue;

    if (eq = strchr(p,'=')) {
      *eq='\0';
      if (found = (!strcmp(s,p)))
      break;

    }
    else
    continue; //while.

  }

  if (!found)
  printf("\"%s\" not found in \"%s\"\n",
  s,numbers_name);

}

/****************************************************************************
Main Screen">
****************************************************************************/
void fixblrs(char *s) {
  char *p;
#ifdef NEED_TO_FIX_PUNC
  int colon=YES;
#endif

//do the colon space, comma space. Also just _s.
  while (p=strchr(s,'_')) {
#ifdef NEED_TO_FIX_PUNC //I don't
    if (p[1]=='_') {

      if (colon)
      p[0] = ':';
      else
      p[0] = ',';

      colon = NO;

      p[1] = ' ';
    }
    else
#endif
    p[0]=' ';

  }


}

char *ind_spaces(int indent) {
  static
      //         0123456789012345678901234567890123456789
  char spaces[]="                                    ";
  static char *empty = "";

  if (!indents)
  return empty;

  enum {
    INDENT_MULT=2,
    SPACE_COUNT= sizeof(spaces)-1,
    MAX_INDENT=(SPACE_COUNT/INDENT_MULT)
  };

  --indent;   //0-base it.

  if (indent<1)
  return empty;

  if (indent>MAX_INDENT)
  indent = MAX_INDENT;

  return spaces+SPACE_COUNT-(indent*INDENT_MULT);

}

void contents(char *s, int indent=0) {
  char *begin, *end;

  if (
  (*s=='_')
  &&
  (exclude_BLRS)
  )
  return;

  begin = s;

  end = strchr(s,'"');

  *end = '\0';

  fixblrs(s);

#if BF_HTM
  bf_htm(s,indent);
#endif

  fprintf(ofile,"%s%s\n",ind_spaces(indent),begin);

  numbers(s);

}

/****************************************************************************
****************************************************************************/
/****************************************************************************
************************************c****************************************/
char *processname;

void process_afile(char *aname) {
  THINGTYPE thing=NOTHING, lastthing;
  int isH, isH1=NO, isH2=NO, isH3=NO;
  char *p;

  processname = aname;

  ifile=fopen(processname,"rb");
  if (!ifile) {
    erprintf(NO,"couldn't open %s",processname);
    return;
  }

/****************************************************************************
;`%s, created by indexhlp `%s
****************************************************************************/

  fprintf(ofile,
  ";%s, created by indexhlp %s from %s\n"
  ,oname
  ,mytime()
  ,processname
  );

  while(1) {
    lastthing=thing;

    if ( (thing=getthing())==NOTHING)
    break;

    switch (thing) {
      case H1: isH1 = YES; isH = 1; break;
      case H2: isH2 = YES; isH = 2; break;
      case H3: isH3 = YES; isH = 3; break;

      case xH1: isH1 = NO; isH = 0; break;
      case xH2: isH2 = NO; isH = 0; break;
      case xH3: isH3 = NO; isH = 0; break;

//    case OTHER_ANGLE:
      case GRAF:
      case CLOSE_GRAF:
      case BREAK:
      isH = isH1 = isH2 = isH3 = 0; break;
/****************************************************************************
clear 'em all for paragraphs, breaks. Ef 'em if they can't take a joke. This
is a pitiful attempt at error avoidance. Although leaving a dangling <H1>
should really be noticeable I'd think....
****************************************************************************/

      case ANCHOR:
      if (
//      (isH1 || isH2 || isH3)
      (isH)
      || anyanchor
      )
      {
/****************************************************************************
<H1><a name="Main Screen">
****************************************************************************/
        if (
        (p=stristr(abuffo,"name")) &&
        (p=stristr(p,"=")) &&
        (p=strchr(p,'"'))
        ) {
          if (!isH)
          contents(p+1,4);    //indent more for non-head. if anyanchor.
          else
          contents(p+1,isH);

        }
      }
      break;
    }
  }
}



/****************************************************************************
****************************************************************************/
/****************************************************************************
****************************************************************************/


#if WILD
void process(void) {
  char *thisname;

  if (!(thisname=getwild(iname)))
  erprintf(NO,"no %s",iname);

/****************************************************************************
Tue 11/13/2007 11:48 am. So this allows an ambiguous file name to be used for
in_file -- but this program won't work that way, I don't think. I've left it
in in case I *do* want to do that later. // And I dumped it with WILD
conditional.
****************************************************************************/

  while(thisname) {
    process_afile(thisname);
    thisname = getwild(NULL);
  }
}
#else
void process(void) {
  process_afile(iname);
}
#endif

/****************************************************************************
indexhlp in_file out_file     Copyright 2001-2007 j.g. owen (`" sTLA `":`"sJGO_XMN `")
Tries to make an adorable list of the H1,H2,H3 referenced targets like <H1><a
name="Main Screen">. Note that it translates _ to space, and *indents* the
list as per H2, H3.
-a      Use *any* anchor.
-i-     Don't indent index items (i.e. indicating H level).
-nfile  Check that anchors are present in the file; emit errors to stdout
        (case sensitive!).
`a#if BF_HTM
-h[`%s] Produce browser/frame version of the help; [default] root; the program
        might produce two files "owenfrm.htm" and "owenidx.htm", i.e. with the
        supplied root. "owenfrm" is the help file.
-t"Help" Provide a title for -h. BLRs converted to spaces, and/or quote.
-p`%d Set the percent of the left frame for the frame version.
-d- *Don't* exclude from indexes links beginning with "_" BLR.
`a#if BF_DIV
-o      do old "&nbsp;" indents; else modern "div em".
`a#endif
`a,frame_rut
`a,frame_percent
`a#endif

****************************************************************************/

void depart(void) {
  fprintf(stderr,







"indexhlp in_file out_file     Copyright 2001-2007 j.g. owen (" sTLA ":"sJGO_XMN ")\n"
"Tries to make an adorable list of the H1,H2,H3 referenced targets like <H1><a\n"
"name=\"Main Screen\">. Note that it translates _ to space, and *indents* the\n"
"list as per H2, H3.\n"
"-a      Use *any* anchor.\n"
"-i-     Don't indent index items (i.e. indicating H level).\n"
"-nfile  Check that anchors are present in the file; emit errors to stdout\n"
"        (case sensitive!).\n"
#if BF_HTM
"-h[%s] Produce browser/frame version of the help; [default] root; the program\n"
"        might produce two files \"owenfrm.htm\" and \"owenidx.htm\", i.e. with the\n"
"        supplied root. \"owenfrm\" is the help file.\n"
"-t\"Help\" Provide a title for -h. BLRs converted to spaces, and/or quote.\n"
"-p%d Set the percent of the left frame for the frame version.\n"
"-d- *Don't* exclude from indexes links beginning with \"_\" BLR.\n"
#if BF_DIV
"-o      do old \"&nbsp;\" indents; else modern \"div em\".\n"
#endif
,frame_rut
,frame_percent
#endif







  );


  exit(17);
}



/****************************************************************************
****************************************************************************/
#define QUESTIONS(s) if ((s) && (strchr(s,'?'))) depart()

_f int notminus(char *arg) {
  return arg[2] != '-';
}

#define NOTMINUS() (notminus(argv[i]))


int main(int argc, char *argv[]) {
  int i, opmark='-';        /* do options. */

#if defined(__FLAT__)
/*ofile = stdout; */
  errout = stderr;
  ofile = stdout;
#endif

  for (i=1; i<argc; ++i) {
    if (argv[i][0]=='/') opmark='/';
/* / forces it to use / subsequently, so u can have files with -. */

    QUESTIONS(argv[i]);

    if (argv[i][0]==opmark) {
      switch (argv[i][1]) {
        case 0: break;
        /* make option alone OK, so he can use files with -. */

        case 'a': anyanchor = NOTMINUS(); break;

        case 'i': indents = NOTMINUS(); break;

        case 'n': numbers_name = argv[i]+2; break;

#if BF_HTM
        case 'h':
        if (frame = NOTMINUS()) {
          if (argv[i][2])
          frame_rut = argv[i]+2;
        }
        break;

#if BF_DIV
        case 'o':
        old_indent = NOTMINUS();
        break;
#endif

        case 'p':
        frame_percent = atoi(argv[i]+2);
        if (
        (frame_percent < 10) ||
        (frame_percent > 90)
        )
        frame_percent = DEF_FRAME_PERCENT;
        break;

        case 't':
        frame_title = deblr(dequote(argv[i]+2));
        break;

#endif

        case 'd':
        exclude_BLRS = NOTMINUS(); break;

        default:
        depart();
      }
    }

    else if (!iname)
    iname = argv[i];
    else if (!oname)
    oname = argv[i];
    else
    depart();

  }

  if (
  (!iname) ||
  (!oname)
  ) depart();

  mustopen(&ofile,oname,"w");

  if (numbers_name)
  mustopen(&numbers_file,numbers_name,"r");

  process();

#if BF_HTM
  end_frame();
#endif

  return 0;

}







