/* jgwrap.c       Wed 8/22/01 3:43 pm
Wed 8/22/01 3:43 pm creation from jgoi.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include <alloc.h>
#include <tla.h>
#if defined(__FLAT__)
#include <stdarg.h>
#endif
#include <io.h>
#include <time.h>

#define YES (1)
#define NO (0)
#define TRUE YES
#define FALSE NO

#define _f  /* harmless prototoype catcher. */
#define _v  /* like same for vars. */


#ifndef BYTE
  #define BYTE char
#endif

typedef unsigned char UCHAR;

#ifndef sBYTE
  #define sBYTE signed char
#endif

#ifndef WORD
  typedef unsigned int WORD;
#endif

#ifndef BIG
  typedef unsigned long BIG;
#endif

#define ARRAYSIZE(x) (sizeof(x) / sizeof(x[0]))

#define ENTER (13)
#define CR (13)
#define LF (10)
#define CTL (0x40)        /* 'A'-CTL is ^A. */
#define ESC (0x1b)
/* #define sESC "\33" */
#define DEL (0x5300)
#define BS (8)
#define TAB (9)

#define sCR  "\xD"
#define sLF  "\xA"
#define sDEL "\x7f"
#define sACK "\x6"
#define sESC "\x1b"
#define sBEL "\x7"

#define BIT0 (1)
#define BIT1 (2)
#define BIT2 (4)
#define BIT3 (8)
#define BIT4 (16)
#define BIT5 (32)
#define BIT6 (64)
#define BIT7 (128)
#define BIT8 (256)
#define BIT9 (512)
#define BIT10 (1024)
#define BIT11 (2048)
#define BIT12 (4096)
#define BIT13 (8192)
#define BIT14 (16384)
#define BIT15 (32768)
#define BIT16 (65536)
#define BIT17 (131072)
#define BIT18 (262144)
#define BIT19 (524288)
#define BIT20 (1048576)
#define BIT21 (2097152)
#define BIT22 (4194304)
#define BIT23 (8388608)
#define BIT24 (16777216)
#define BIT25 (33554432)
#define BIT26 (67108864)
#define BIT27 (134217728)
#define BIT28 (268435456)
#define BIT29 (536870912)
#define BIT30 (1073741824)
#define BIT31 (2147483648)

#define nBIT(x) (1 << (x))                          /*  */
/* this doesn't work with BIGs. Then it should be
  #define nBIT(x) ((BIG)(((BIG)1) << ((BIG)x)))
*/

#define lo(one,two) ( ((one) < (two)) ? (one) : (two))    /*  */
#define hi(one,two) ( ((one) > (two)) ? (one) : (two))    /* not tested. */

#define kLOW(x) ((x) & 255)
#define kHIGH(x) (((x) >> 8)&255)

/* kill annoying error messages from JGW LOW, HIGH def. */
#ifdef LOW
  #undef LOW
#endif
#ifdef HIGH
  #undef HIGH
#endif

#define LOW(x)  (((BYTE *)&(x))[0])
#define HIGH(x) (((BYTE *)&(x))[1])

/****************************************************************************
some harmless prototypes.
****************************************************************************/
void depart(void);

/****************************************************************************
****************************************************************************/

#define FIX2LINES YES
#define REMOVE2LINES FIX2LINES

#define FINDEVIL FALSE

#define FIXLINES3 FALSE /* try again. */

#define FIXLINES4 TRUE  /* and again. */
#define FIXLINES5 TRUE  /* strip empty lines.*/

/*#define DATETIME TRUE   /* provide date time code. //always true.*/

#define DUMP_GETTHING_LINES TRUE

#define NBSP TRUE       /* fix &nbsp; to space. For Kompozer. */

#define DUMP_CHROME TRUE  /* idiotic <img
src="chrome://editor/content/images/tag-comment.gif"> */

/****************************************************************************
****************************************************************************/
char *iname, *thisname, *processname;

FILE *ifile;

int wrap=70, cute=YES, deindent=YES, keeptemps;

char *debug;

#define DQUOTE '\"'
#define SQUOTE '\''

char *rightsquote  = "&#146;";

char *opendquotes  = "&#147;";
char *closedquotes = "&#148;";

char *stupidquote =  "&quot;";

#if NBSP
char *nbsp =  "&nbsp;";
#endif


int textquote;

FILE *xfero;
char *xfername;

int linecount, ccount;

char *badquotename="bad~q~";

int nonspace;

int gotrightangle;
/* set when right angle is gotten; must be reset by others. */

char *jgodontwrap = "<!-- JGODONTWRAP -->";

char *jgodatetime = "<!-- $JGO$:DATETIME -->";
char *jgoclose    = "<!-- $JGO$:CLOSE -->";
int datetime = 1;

char *jgouncurly  = "<!-- $JGO$:UNCURLY -->";
char *jgocurly    = "<!-- $JGO$:CURLY -->";

#if DUMP_CHROME
/****************************************************************************
<img src="chrome://editor/content/images/tag-comment.gif">
****************************************************************************/

char *chrome_junk =

"<img src=\"chrome://editor/content/images/tag-comment.gif\">"

;

int dump_chrome = YES;

#endif

int uncurly;

int skipwrap, quotepar=YES, fixwebx=YES;

#if NBSP
int fixnbsp=YES;
#endif

int changed;

#if FIXLINES4
int changed4;
int untrail=YES;
#if FIXLINES5
int unempty=YES;
#endif
#endif



#if REMOVE2LINES
int remove2lines, remove2now;
#endif

/****************************************************************************
****************************************************************************/

int errorcount;

FILE *errout
#if !defined(__FLAT__)
=stderr
#endif
;


/* returns -1 so functions can return it as error I guess. */
_f int erprintf(int terminal, char *format, ...) {
  va_list argptr;

  char abuf[10];

  va_start(argptr, format);
  vfprintf(errout,format,argptr);
  va_end(argptr);
  fputc('\n',errout);

  ++errorcount;

  if (terminal) {
    fprintf(errout," (press enter)");
    fgets(abuf,5,stdin); /* hope you didn't redirect */
    exit(terminal);
  }
  return -1;
}


/****************************************************************************
****************************************************************************/
_f char *mytime(void) {
  time_t secs_now;
  struct tm *tm_now;
  WORD hour;
  static char thistime[37];
  static char *weekdays[7] = {
    "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday",
    "Saturday" };
  char *ampm;

  time(&secs_now);
  tm_now = localtime(&secs_now);
  hour = tm_now->tm_hour;
  if (tm_now->tm_hour >= 12) {
    ampm="pm";
    if (tm_now->tm_hour>12)
    hour -= 12;
  }
  else ampm="am";

  sprintf(thistime,"%s %u/%u/%02u %u:%02u %s",
  weekdays[tm_now->tm_wday],
  tm_now->tm_mon+1,
  tm_now->tm_mday,
  tm_now->tm_year % 100,
  hour,
  tm_now->tm_min,
  ampm);
  return thistime;
}

_f void mustopen(FILE **f, char *name, char *mode) {
  if (!(*f=fopen(name,mode))) {
    fprintf(stderr,"couldn't open %s for %s.",name,mode);
    exit(3);
  }
}

_f void empty(char *s) {
  FILE *t;
  mustopen(&t,s,"w");
  fclose(t);
}

_f void *mustalloc(unsigned size) {      /* clears block to zero. */
  void *p;
  if ((p=calloc(size,1)) != NULL)
  return p;
  fprintf(stderr,"ran out of memory.");
  exit(7);
}

/****************************************************************************
****************************************************************************/
#define BKEXT ".b~k"
_f char *dobakname(char *name) {
  char
  drive[MAXDRIVE],
  dir[MAXDIR],
  file[MAXFILE],
  bakname[MAXPATH];

  fnsplit(name,drive,dir,file,NULL);
  fnmerge(bakname,drive,dir,file,BKEXT);


  unlink(bakname);

  return
  strdup(bakname);
}



/****************************************************************************
****************************************************************************/

#if defined(__FLAT__)
void *findfinish(struct ffblk *ffblk) {
  findclose(ffblk);
  return NULL;
}
#else
#define findfinish(x) NULL
#endif

/* If name, returns first next instance of name (NULL if none). If name==NULL,
returns next (NULL if none). */

_f char *getwild(char *name) {
  static char path[MAXPATH], drive[MAXDRIVE],
  dir[MAXDIR], file[MAXFILE], ext[MAXEXT];
  static struct ffblk ffblk;
  if (name) {
    fnsplit(name,drive,dir,file,ext);
    if (findfirst(name,&ffblk,0))
    return findfinish(&ffblk);
  }
  else {
    if (findnext(&ffblk))
    return findfinish(&ffblk);
  }
  fnsplit(ffblk.ff_name,NULL, NULL,file,ext);
  fnmerge(path,drive,dir,file,ext);
  return path;
}

/* return nz if file name exists. evades append. */
_f int exist(char *name) {
  return !access(name,0);
}

/****************************************************************************
****************************************************************************/

#define JGTEMP ".J~G"
_f int ainc(char *tname) {   /* this crashes unless tname is correctly formed. */
  int i=6;
  while(i>=0) {
    if (++tname[i] > 'Z') {
      tname[i]='A';
      --i;
    }
    else
    return 0;
  }
  return -1;
}

/* if no ext, uses the current one. */
_f char *musttemp(char *ext) {
                  /*   01234567890123 */
  static char tname[MAXFILE+MAXEXT]="AAAAAAA~" JGTEMP;
  char tfile[MAXFILE];
  char *t;

  if (ext) {
    fnsplit(tname,NULL,NULL,tfile,NULL);
    fnmerge(tname,NULL,NULL,tfile,ext);
  }

  while(exist(tname)) {
    if (ainc(tname))
    erprintf(YES,"Ran out of temp names!?");
  }
  t=mustalloc(sizeof(tname));
  strcpy(t,tname);
  empty(t);
/*addtemp(t);*/
  return t;
}


_f char *musttemporary(void) {
  return
  musttemp(JGTEMP);
}

_f void killtemps(void) {
  char *t=getwild("*" JGTEMP);
  while(t) {
    unlink(t);
    t=getwild(NULL);
  }
}

_f char *anothername(char *s) {
  static char rutname[MAXFILE];
  static char newname[MAXFILE+MAXEXT];
  char ext[MAXEXT], xchar='A';
  int i, xindex = 3;

  if (!exist(s))
  return s;

  fnsplit(s,NULL,NULL,rutname,ext);

  if (!ext[0])
  strcpy(ext,".___");
  else {
    for (i=1; i<=3; ++i)
    if (!ext[i]) {
      ext[i]='_';
      ext[i+1]=0;
    }
  }

  while(1) {
    ext[xindex]=xchar;

    fnmerge(newname,NULL,NULL,rutname,ext);

    if (!exist(newname))
    return newname;

/* prepare the next. */
    if (!xindex)
    erprintf(YES,"don't have anothername");

    ++xchar;
    if (xchar>'Z') {
      xchar='A';
      --xindex;
    }
  }
}

/****************************************************************************
hopefully at beginning of line.
****************************************************************************/
void emitdebug(void) {
  if (debug)
  fprintf(xfero,"q:%d: ",textquote);
}


/****************************************************************************
****************************************************************************/
#if FINDEVIL
char *who="";
findevillf(char *what) {
  printf("LF: line: %d; count: %d; what:%s; who:%s\n",
  linecount+1,ccount,what,who);
}
#endif

/****************************************************************************
getcharacter from ifile, send it to ofile.
****************************************************************************/

#if REMOVE2LINES

#if FIXLINES3
long CRtell;
#endif

int getxfer(void) {
  int c;
  static int wasLF;

  NASTYLABEL:

  c=getc(ifile);

  wasLF |= (c==LF);

  if (c==CR) {
    if (
    (wasLF) && (remove2now)
    ) {
      changed = YES;
      getc(ifile);        /* throw away the LF. */
      goto NASTYLABEL;    /* I just love it when I do that. */
    }
#if FIXLINES3
    CRtell=ftell(xfero);
#endif
  }

  if (c>=' ')
  wasLF = NO;


#if FINDEVIL
  if (c==LF)
  findevillf("getxfer");
#endif

  if (c!=EOF)
  fputc(c,xfero);

  ++ccount;

  if (c==LF)
  ccount = 0;   /* this was supposed to fix the double-line problem.*/

  return c;
}


#else

int getxfer(void) {
  int c;

  c=getc(ifile);


  if (c!=EOF)
  fputc(c,xfero);

  ++ccount;

#if FIX2LINES
  if (c==LF)
  ccount = 0;
#endif

  return c;
}
#endif


/* shouldn't put line-ending characters back or anything. */
void ungetxfero(int howmany) {
  long where=ftell(xfero);
  fseek(xfero,where-howmany,0);

  if (ccount>=howmany)
  ccount -= howmany;
#if FIXLINES3
  else
  ccount=0;
#endif
}

void ungetxferi(int howmany) {
  long where=ftell(ifile);
  fseek(ifile,where-howmany,0);
}

void ungetboth(int howmany) {
  ungetxfero(howmany);
  ungetxferi(howmany);
}

void wrapbreak(void) {
#if 0 /*FIX2LINES */
  if (ccount)
#endif
#if FIXLINES3
static long thistell;

  thistell = ftell(xfero);
  if ( (thistell-CRtell)<wrap)
  return;

  CRtell=thistell;

#endif

#if FINDEVIL
  findevillf("wrapbreak");
#endif
  fputs("\r\n",xfero);
  ++linecount;
  ccount=0;
  emitdebug();
}

void xoutstring(char *s) {
#if FINDEVIL
  if (strchr(s,LF))
  findevillf("xoutstring");
#endif
  fputs(s,xfero);
  ccount += strlen(s);
}


void ungetxstring(char *s) {
  ungetxfero(strlen(s));
}

/****************************************************************************
****************************************************************************/
#define BSIZE (200)
char abuffo[BSIZE+5];


typedef enum {
  NOTHING=0,
  LEFTANGLE,
  RIGHTANGLE,
  ACHARACTER,
  ASPACE,
  AMP_OPEN,
  AMP_CLOSE,
  AMP_STUPIDQUOTE,
  AMP_ELSE,
#if NBSP
  AMP_NBSP,
#endif
  NAKED_DQUOTE,
  NAKED_SQUOTE,
  OPENPARAGRAPH,
  JGODONTWRAP,
  JGODATETIME,
/*  JGOCLOSE, */
  ANCHOR    /* <A */


} THINGTYPE;

int ismypunk(int c) {
  return
  ispunct(c) &&
  (!strchr("!-#",c));
}

THINGTYPE getthing(void) {
  int c, index;
  char *p;

  if (gotrightangle)
  return RIGHTANGLE;

  while (1) {
    LOOPANYWAY:   /* truly evil. */

#if FINDEVIL
    who="getthing1";
#endif
    c = getxfer();

    if (
    (c==' ') || (c==TAB)
    ) {
      if (deindent && (!nonspace)) {
        ungetxfero(1);
        changed=YES;
        continue;      /* while. */

      }
      return ASPACE;

    }
    else nonspace=YES;

    switch (c) {
      case EOF:
      return NOTHING;

      case '>':
      gotrightangle=YES;
      return RIGHTANGLE;

      case '<':
      p=abuffo;
      abuffo[0]='<';
      abuffo[1]='\0';
      while(1) {
        if ( (p-abuffo) > BSIZE)
        goto JUSTLEFTANGLE;

        ++p;
#if FINDEVIL
        who="getthing2";
#endif
        *p=getxfer();
        p[1]='\0';
#if DUMP_GETTHING_LINES
        if ((*p==LF) && (p[-1]==CR)) {
          --p;
          *p = ' ';
          p[1]='\0';
        }
#endif
        if (*p=='>') {
#if 0 /*FINDEVIL */
          if (!stricmp(abuffo,"<A HREF=\"rant6.htm#jgup\">"))
          printf("Hey babe rants away!\n");
#endif

/* here is where to trap the odd junk. */

#if DUMP_CHROME
          if (
          dump_chrome
          &&
          (stricmp(abuffo,chrome_junk)==0)
          ||
          (
/*                         12345678          */
          (strncmp(abuffo,"<comment",8)==0)

/****************************************************************************
xmlns="http://disruptive-innovations.com/zoo/nvu"
****************************************************************************/

          && strstr(abuffo,


"xmlns=\"http://disruptive-innovations.com/zoo/nvu\""


          )
          )
          )

          {
            ungetxstring(abuffo);   /* just toss it. */
            changed=YES;
            break;
          }

#endif

          if (stricmp(abuffo,jgouncurly)==0) {
            uncurly=YES;
          }

          if (stricmp(abuffo,jgocurly)==0) {
            uncurly=NO;
          }

          if (stricmp(abuffo,jgodontwrap)==0) {
            skipwrap=YES;
            return JGODONTWRAP;
          }

          if (datetime && (!stricmp(abuffo,jgodatetime))) {
            changed = YES;
            fprintf(xfero,"%s",mytime());
            while(1) {
              switch (getc(ifile)) {

                case EOF:
                erprintf(YES,"very lengthy %s",jgodatetime);
                goto LOOPANYWAY;
/*                break; /* switch. */

                case '<':
                ungetxferi(1);
                goto LOOPANYWAY;

              }
            }
          }

          if (strnicmp(abuffo,"<P",2)==0)
          return OPENPARAGRAPH; /* if the caller is interested, he can check
          the buffer. */

          if (strnicmp(abuffo,"<A",2)==0)
          return ANCHOR;

          break; /* the while. got unrecognized <>, so put it back. */
        }
      }

      JUSTLEFTANGLE:
      ungetboth(strlen(abuffo)-1);  /*throw back everything but the <. */
      return LEFTANGLE;

      case '\n':
      linecount++;
      ccount = 0;
      nonspace=NO;
      emitdebug();
      case '\r':
      continue;

/*it's some idiotic ampserand character.*/
      case '&':
      p=abuffo;
      abuffo[0]='&';
      abuffo[1]='\0';

      while (1) {
        if ( (p-abuffo) > 25)
        erprintf(YES,"extremely long &character; in %s\n(check %s)",
        processname,xfername);

        ++p;

#if FINDEVIL
        who="getthing3";
#endif
        *p=getxfer();
        p[1]='\0';
        if (*p==';') {

          if (strcmp(abuffo,opendquotes)==0)
          return AMP_OPEN;

          if (strcmp(abuffo,closedquotes)==0)
          return AMP_CLOSE;

          if (strcmp(abuffo,stupidquote)==0)
          return AMP_STUPIDQUOTE;

#if NBSP
          if (strcmp(abuffo,nbsp)==0)
          return AMP_NBSP;
#endif

          return AMP_ELSE;

        }
      }

      default:
      if (c<=' ')
      continue;       /* just forget strangeness. */

      abuffo[0] = c;

      if (c==DQUOTE)
      return NAKED_DQUOTE;

      if (c==SQUOTE)
      return NAKED_SQUOTE;

      return ACHARACTER;

    }
/* so it's not one of our exciting punctuations. */
  }
}


/****************************************************************************
****************************************************************************/
void dumpangle(THINGTYPE thing) {
  int anglequote= (thing==DQUOTE);
  /* I assume you're dumping from a safe place. May have to revise this
  assumption.*/

  if (gotrightangle) {
    gotrightangle=NO;
    return;
  }

  while (
  (thing != RIGHTANGLE) &&
  (thing=getthing())
  ) {
    if (thing==NAKED_DQUOTE)
    anglequote = !anglequote;

    if (
    (!skipwrap) &&
    (thing==ASPACE) &&
    (!anglequote) &&
    (ccount>wrap)
    ) {
#if 0 /* FINDEVIL wasn't it. */
#else
      ungetxfero(1);
#if FINDDEVIL
      who="dumpangle";
#endif
      wrapbreak();
#endif
    }
  }
}

/****************************************************************************
****************************************************************************/

void processwrapcute(char *aname) {
  THINGTYPE thing=NOTHING, lastthing;

  processname = aname;

  ifile=fopen(processname,"rb");
  if (!ifile) {
    erprintf(NO,"couldn't open %s",processname);
    return;
  }

  xfername=musttemporary();
  xfero=fopen(xfername,"wb+");

  uncurly=
  skipwrap=
  nonspace=changed=textquote=errorcount=linecount=ccount=0;

  while(1) {
    lastthing=thing;

    if ( (thing=getthing())==NOTHING)
    break;

    gotrightangle = NO;   /* reset gotrightangle trap. */

    switch (thing) {
      case LEFTANGLE:
      dumpangle(getthing());
      break;

      case OPENPARAGRAPH:
      if (quotepar)
      textquote = NO;     /* reset cute quotes at paragraphs */
      skipwrap=NO;        /* reset wrap defeat. */
#if REMOVE2LINES
      remove2now=remove2lines;
      /* don't remove them before a paragraph, so all that header junk
      doesn't get changed. */
#endif
      break;

/****************************************************************************
try to fix

<!-- JGODONTWRAP --><FONT COLOR="#00007F">The Rant pages:</FONT>
<A HREF="rant.htm">Rant</A>.<A HREF="rant2.htm"> Rantano2</A>.<A HREF="rant3.htm">
                                                
this space here 

That is basically, JGODONTWRAP has become JGODONT fiddle with Webx's
pecularities, or if you must, somehow fix them. And it worked at least once.

****************************************************************************/

      case ASPACE:
      if (skipwrap && fixwebx && (lastthing==ANCHOR)) {
/* correct a particular webx idiosyncrasy. */
        ungetxfero(strlen(abuffo)+1);
          /* this depends on the ASPACE getthing() not trashing abuffo. But of
          course it wouldn't do that. */

#if FINDEVIL
        who="processwrapcute2";
#endif
        xoutstring(" ");     /* put the space first. */
        xoutstring(abuffo);  /* *now* the ref. */
      }
      else
      if ((!skipwrap) &&
      (ccount>wrap)) {  /* it's ok to break a quote in text. */
        changed=YES;
        ungetxfero(1);
#if FINDEVIL
        who="processwrapcute3";
#endif
        wrapbreak();
      }
      break;

/*just do them all together. You must balance ur quotes. */
      case AMP_CLOSE:
      case AMP_OPEN:
      case AMP_STUPIDQUOTE:

      if ((!cute) || uncurly)
      break;

      ungetxstring(abuffo);
      goto SENDAQUOTE;

#if NBSP
      case AMP_NBSP:
      if ( (!cute) || uncurly || (!fixnbsp) )
      break;

      ungetxstring(abuffo);
      xoutstring(" ");
      changed=YES;
      break;
#endif

      case NAKED_DQUOTE:

      if ( (!cute)
      || (uncurly)  /*missing (?) until Wednesday, May 3, 2006 1:26 pm*/
      )
      break;

      ungetxfero(1);

      SENDAQUOTE:

#if FINDEVIL
      who="processwrapcute4";
#endif
      if (textquote) {
        xoutstring(closedquotes);
        if (thing!=AMP_CLOSE)
        changed=YES;
      }
      else {
        xoutstring(opendquotes);
        if (thing!=AMP_OPEN)
        changed=YES;
      }

      textquote = !textquote;

/*this is getting set erroneously Thu 1/10/02 6:38 pm. */
/*      changed=YES;   */

      break;

      case NAKED_SQUOTE:
      if ( (!cute) || uncurly)
      break;

      changed=YES;
      ungetxfero(1);
#if FINDEVIL
      who="processwrapcute5";
#endif
      xoutstring(rightsquote);
      break;

    }
  }
  fclose(ifile);

  fclose(xfero);

  if (textquote && (!quotepar)) {
    if (debug) {
      unlink(debug);
      rename(xfername,debug);
    }
    free(xfername);
    if (debug)
    erprintf(YES,"unbalanced quotes in %s (see %s)",processname,debug);
    else
    erprintf(YES,"unbalanced quotes in %s (try -d option)",processname);
  }

  else if (changed) {
#if FIXLINES4
    char *bname;
    if (changed4) {
      unlink(processname);  /* trailing space code already backed-up. */
    }
    else {
      bname=dobakname(processname);
      unlink(bname);
      rename(processname,bname);
      free(bname);
    }

    rename(xfername,processname);
#else
    char *bname=dobakname(processname);
    unlink(bname);
    rename(processname,bname);
    free(bname);

    rename(xfername,processname);
#endif
    printf("Updated %s\n",processname);
  }
  else if (!keeptemps)
  unlink(xfername);

  free(xfername);

}

/****************************************************************************
****************************************************************************/
#if FIXLINES4
_f char *f0gets(char *string, int n, FILE *stream) {
  char *p, *t;
  if ( (p=fgets(string,n,stream)) &&
       (t=strchr(p,'\n')) ) *t='\0';
  return p;
}

#if FIXLINES5
/* scan off of spaces in s; stop at any non-blank, including \0, \n. Return
1 if end of line -- \n \0, else 0. Mon 05-15-1995 version.*/
_f int scans(char **s) {
  while (**s && (**s<=' ') && (**s != '\n') )
  ++(*s);

  return **s=='\n' || **s=='\0';
}
#endif

void processtrailspace(char *aname) {
  FILE *ifile, *ofile;
  char *xfername, *p, *abuffo;
  enum {
    ABSIZE=10000
  };

  changed4=NO;

  if (debug || (!untrail))    /* just skip it. */
  return;

  abuffo=mustalloc(ABSIZE);

  mustopen(&ifile,aname,"r");

  xfername=musttemporary();
  mustopen(&ofile,xfername,"w");

  while(f0gets(abuffo,ABSIZE,ifile)) {
#if FIXLINES5
    if (unempty) {
      p = abuffo;
      if (scans(&p)) {
        changed4=YES;
        continue;   /* just dump it. */
      }
    }
#endif

    p = abuffo + strlen(abuffo) - 1;

    while ( isspace(*p) && (p>abuffo) ) {
      *p='\0';
      --p;
      changed4=YES;
    }

    fprintf(ofile,"%s\n",abuffo);
  }

  fclose(ifile);
  fclose(ofile);

  if (changed4) {
    char *bname=dobakname(aname);
    unlink(bname);
    rename(aname,bname);
    rename(xfername,aname);
    free(bname);
#if FIXLINES5
    if (unempty)
    printf ("Removed trailing spaces/emtpy lines from %s\n",aname);
    else
#endif
    printf("Removed trailing spaces from %s\n",aname);

  }
  else if (!keeptemps)
  unlink(xfername);

  free(xfername);

  free(abuffo);


}

#endif


/****************************************************************************
****************************************************************************/


void process(void) {


  if (!(thisname=getwild(iname)))
  erprintf(NO,"no %s",iname);

  while(thisname) {
#if FIXLINES4
    processtrailspace(thisname);
#endif

    processwrapcute(thisname);

    thisname = getwild(NULL);
  }
}


/****************************************************************************

jgwrap [options] [AFN [AFN...]     Copyright 2001-2007 j.g. owen (`" sTLA `")
-c- don't make quotes cute, change &nbsp; to space for Komposer. Also
`%s text `%s suppresses temporarily?
-n- don't change &nbsp; to space for Komposer.
-p- if cute quotes, don't reset them at paragraphs, and if unbalanced quotes,
  make error.
-dFilename Emit a debug file with map of double quotes if quote error. If no
  name, use `%s (incidentally, use two single quotes for inches).
  Don't remove trailing spaces.
-k keep temps
-i- don't remove leading space indents.
-t- don't remove trailing spaces or empty lines.
-u- don't remove empty lines.
-w`%u   wrap margin (default)
-- ops finished, so you can use a file with stupid -name
If `%s, don't wrap until <P>. And fix webx <A> problem.
-x- Don't fix webx problems.    -f- don't dump disruptive-innovations junk
-e Remove some extra CRLFs.
-y- Don't date/time like `%sxxx`%s
    (it's a kluje; no "<"s allowed in "xxx"!)
`a#ifdef __FLAT__
(w32)
`a#endif
`a,jgouncurly,jgocurly,badquotename,wrap,jgodontwrap,jgodatetime,jgoclose

****************************************************************************/

void depart(void) {
  printf(







"jgwrap [options] [AFN [AFN...]     Copyright 2001-2007 j.g. owen (" sTLA ")\n"
"-c- don't make quotes cute, change &nbsp; to space for Komposer. Also\n"
"%s text %s suppresses temporarily?\n"
"-n- don't change &nbsp; to space for Komposer.\n"
"-p- if cute quotes, don't reset them at paragraphs, and if unbalanced quotes,\n"
"  make error.\n"
"-dFilename Emit a debug file with map of double quotes if quote error. If no\n"
"  name, use %s (incidentally, use two single quotes for inches).\n"
"  Don't remove trailing spaces.\n"
"-k keep temps\n"
"-i- don't remove leading space indents.\n"
"-t- don't remove trailing spaces or empty lines.\n"
"-u- don't remove empty lines.\n"
"-w%u   wrap margin (default)\n"
"-- ops finished, so you can use a file with stupid -name\n"
"If %s, don't wrap until <P>. And fix webx <A> problem.\n"
"-x- Don't fix webx problems.    -f- don't dump disruptive-innovations junk\n"
"-e Remove some extra CRLFs.\n"
"-y- Don't date/time like %sxxx%s\n"
"    (it's a kluje; no \"<\"s allowed in \"xxx\"!)\n"
#ifdef __FLAT__
"(w32)\n"
#endif
,jgouncurly,jgocurly,badquotename,wrap,jgodontwrap,jgodatetime,jgoclose










  );


  exit(17);
}



/****************************************************************************
****************************************************************************/
#define QUESTIONS(s) if ((s) && (strchr(s,'?'))) depart()

_f notminus(char *arg) {
  return arg[2] != '-';
}

#define NOTMINUS() (notminus(argv[i]))


int main(int argc, char *argv[]) {
  int nonops=0, i, opmark='-';        /* do options. */
  int opsdone=0;
#if defined(__FLAT__)
/*ofile = stdout; */
  errout = stderr;
#endif

  for (i=1; i<argc; ++i) {
    if (argv[i][0]=='/') opmark='/';
/* / forces it to use / subsequently, so u can have files with -. */

    if (!opsdone)
    QUESTIONS(argv[i]);

    if ( (argv[i][0]==opmark) && (!opsdone)) {
      switch (argv[i][1]) {
        case 0: break;
        /* make option alone OK, so he can use files with -. */

        case '-': opsdone=YES; break;

        case 'c': cute=NOTMINUS(); break;
        case 'd':
        debug=argv[i]+2;
        if (!*debug)
        debug = badquotename;
        break;

#if REMOVE2LINES
        case 'e': remove2lines=NOTMINUS(); break;
#endif

#if DUMP_CHROME
        case 'f': dump_chrome=NOTMINUS(); break;
#endif

        case 'i': deindent=NOTMINUS(); break;

        case 'k': keeptemps=NOTMINUS(); break;

        case 'p': quotepar=NOTMINUS(); break;

#if FIXLINES4
        case 't': untrail=NOTMINUS(); break;

#if FIXLINES5
        case 'u': unempty=NOTMINUS(); break;
#endif
#endif

        case 'w': wrap=atoi(argv[i]+2); break;

        case 'x': fixwebx=NOTMINUS(); break;

        case 'y': datetime=NOTMINUS(); break;

#if NBSP
        case 'n': fixnbsp=NOTMINUS(); break;
#endif


        default:
        depart();
      }
    }
    else
    ++nonops;
  }

  opsdone=NO;

  if (nonops) {
    for (i=1; i<argc; ++i) {
      if ( (argv[i][0]=='-') && (!opsdone) ) {
        if (argv[i][1]=='-')
        opsdone=YES;
        continue;
      }

      iname = argv[i];

      process();

    }
  }
  else
  depart();

  return 0;

}



