unit jhelp;

{$define STAND_ALONE}
//else use it as part of a Delphi 7 (+?) program.

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, StdCtrls, ExtCtrls, Buttons, CheckLst;

type
  Tjgowen_helpf = class(TForm)
    Panel1: TPanel;
    Edit1: TEdit;
    Button_search: TButton;
    BitBtn_Cancel: TBitBtn;
    Splitter1: TSplitter;
    ListBox1: TListBox;
    BitBtn1: TBitBtn;
    Label_search: TLabel;
    WebBrowser1: TWebBrowser;
    BitBtn_Goback: TBitBtn;
    Timer_IPC: TTimer;
    BitBtn_Unmark: TBitBtn;
    //I put it under the stop button.
    procedure Button_searchClick(Sender: TObject);
    procedure BitBtn_CancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn_GobackClick(Sender: TObject);
    procedure Timer_IPCTimer(Sender: TObject);
    procedure BitBtn_UnmarkClick(Sender: TObject);
  private
    jshowing : boolean;
    procedure loadhelp(anchor:string = '');
    { Private declarations }
    procedure loadcontents;
    procedure loadnumbs;
    procedure xinit;
    procedure search;
    procedure clrsearch;
    procedure fiddle_help;
{$ifdef STAND_ALONE}
    procedure standalone_startup;
    procedure readini;
    procedure read_fiddle;
    procedure focus;
{$endif}
  public
    { Public declarations }
  end;

var
  jhelpf: Tjgowen_helpf;

//these would be used if you incorporate this into a program.
procedure showhelp(s:string); overload;
procedure showhelp(x:integer); overload;

implementation

{$R *.dfm}

uses mshtml
, sbrs
//, code
//,wlc6log
,inifiles
;

{$I tla.i}

var
stop_search:boolean;

{****************************************************************************
****************************************************************************}

procedure Tjgowen_helpf.FormCreate(Sender: TObject);
begin
  autoscroll := true;
  top := 0;
  left := 0;
end;


{****************************************************************************
****************************************************************************}
const

//these are concocted by program logic from stuff in Goptions.

thehelp:string = 'owenhelp.htm';
//the single htm file with help.

thecontents:string = 'owenhelp.idx';
//created by the utility program helpidx from html help.

thenumbers:string = 'owenhelp.num';
{****************************************************************************
created by hand -- manually, by *you* -- from thecontents, if you want to use
numeric help. This is more likely if you're using owenhelp as part of a Delhi
program; Delphi stores help context as numbers. The idea is you'd *edit*
owenhelp.num so it's a bunch of entries like "Edit: Cut=8;"; this thing might
be read in here, the numbers tucked away, and then the overloaded
showhelp(x:integer) could be passed one of these numbers.
****************************************************************************}

type

Rhelpops = record
  helpdir,
  helpname,
  helpidx,
  helpnumb:string;
  top,left,height,width:integer;
end;

const

Goptions : Rhelpops = (
  helpdir:  'helphtm\';
  //i.e. off program directory. If a full path then program directory is
  //ignored.

  helpname: 'owenhelp.htm';
  helpidx:  'owenhelp.idx';
  helpnumb: 'owenhelp.num';

//make height/width "don't set" by default. I *like* top/left defaulting
//to zero.
  top : -1;
  left : -1;
  height : -1;
  width : -1;

);


procedure Tjgowen_helpf.loadcontents;
var
i:integer;
error:boolean;
begin
  error := false;
  try
    ListBox1.Items.LoadFromFile(thecontents);
  except
    on exception do begin
      errorf('Couldn''t load %s; sorry',[thecontents]);
      error := true;
    end;
  end;

  if error then
  close;

  i := 0;

  while i < ListBox1.items.count do begin
    if es(ListBox1.items[i],1)=';' then
    ListBox1.items.delete(i)
    else
    inc(i);
  end;
end;

procedure Tjgowen_helpf.ListBox1Click(Sender: TObject);
begin
  if Listbox1.itemindex >= 0 then
  loadhelp(Listbox1.items[Listbox1.itemindex]);

end;


{****************************************************************************
****************************************************************************}
function WBLocateHighlight(WB: TWebBrowser; Text: string):integer; forward;

procedure Tjgowen_helpf.loadhelp(anchor:string = '');
begin

//remove indents or something.
  anchor := trim(anchor);

  if anchor<>'' then
//blrize 'em. and make it a suitable HTML target.
  anchor := '#'+blrize(anchor);

  clrsearch;
  Webbrowser1.Navigate(thehelp+anchor);
end;

{****************************************************************************
got from http://delphi.about.com/od/adptips2004/a/bltip1004_3.htm I think....
and so much more at
http://delphi.about.com/b/2004/05/27/webbrowser-to-the-max.htm

Usage:
WBLocateHighlight(WebBrowser1,'delphi') ;

Wednesday, October 17, 2007 11:54 am. So on XP at least, it's
case-insensitive. So all these odd com-like things are googable....

****************************************************************************}
function WBLocateHighlight(WB: TWebBrowser; Text: string):integer;
const
  prefix = '<span style="color:white; background-color: red;">';
  suffix = '</span>';
var
  tr: IHTMLTxtRange;
begin
  result := 0;

  if Assigned(WB.Document) then
  begin

    tr := ((wb.Document AS IHTMLDocument2).body
    AS IHTMLBodyElement).createTextRange;

    while tr.findText(Text, 1, 0) do
    begin
      inc(result);
      Application.ProcessMessages;
      if stop_search then
      exit;
      tr.pasteHTML(prefix + tr.htmlText + suffix) ;
      tr.scrollIntoView(True) ;
    end;
  end;
end;


{****************************************************************************
****************************************************************************}

procedure Tjgowen_helpf.search;
var
r, i:integer;
begin
  clrsearch;
  stop_search := false;
  BitBtn_Cancel.visible := true;
  loadhelp('');
  Application.ProcessMessages;
  if (Edit1.Text='')
  or (Edit1.Text=' ') // doesn't like that either
  then
  exit;

  r := -1;

  for i := 1 to 3 do begin
    try //it's a cranky li'l feller....
      mswait(500);
      r := WBLocateHighlight(Webbrowser1, Edit1.Text);
      break;  //for?
    except on
      Exception do;
    end;
  end;

  BitBtn_Cancel.visible := false;

  if r=0 then
  label_search.caption := 'not found'
  else if r>0 then begin
    label_search.caption := safe_format('%d found',[r]);
    BitBtn_Unmark.visible := true;
  end;

end;

procedure Tjgowen_helpf.Button_searchClick(Sender: TObject);
begin
  search;
end;

procedure Tjgowen_helpf.BitBtn_CancelClick(Sender: TObject);
begin
  stop_search := true;
end;

procedure Tjgowen_helpf.FormShow(Sender: TObject);
begin
  xinit;
//  loadcontents;
  loadhelp;
  jshowing := true;
  BitBtn_Cancel.Visible := false;
end;

procedure Tjgowen_helpf.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  stop_search := true;
  jshowing := false;
end;

{****************************************************************************
help Contents=1;
help Main Screen=2;
help Menus=3;
****************************************************************************}
//var
//numbers : TStringList;

//must follow loadcontents.
procedure Tjgowen_helpf.loadnumbs;
var
h, number, index, p:integer;
name, s:string;

begin
  h := FileOpen(thenumbers,fmOpenRead);

  if h<0 then begin
//    logelse('couldn''t open "%s"',[thenumbers]);
    exit;
  end;

  while hgets(h,s) do begin
    if es(s,1)=';' then
    continue;

    p := pos('=',s);

    if p<1 then
    continue;

    number := JgoStrToInt(copy(s,p+1,5000));
    name := copy(s,1,p-1);

    index := ListBox1.items.IndexOf(name);

    if index<0 then
    continue;

    ListBox1.items.objects[index] := Tobject(number);

  end;

  FileClose(h);

end;

{****************************************************************************
****************************************************************************}
{$ifdef STAND_ALONE}
const
ininame : string = 'owenhelp.ini';
SECNAME = 'options';

var
pleasefind : string;
pleasefocus : integer;
pleaseclose : boolean;

please_load_help : boolean;


procedure Tjgowen_helpf.readini;
var
IniFile : TIniFile;
x:integer;

  function readstr(what,def:string; var flag:boolean):string;
  var
  s:string;
  begin
    s := inifile.readstring(SECNAME,what,'');
    if s='' then
    result := def
    else begin
      result := s;
      flag := true;   //note that it happened.
    end;

  end;

  function readint(what:string; def:integer):integer;
  var
  val:integer;
  begin
    val := inifile.readinteger(SECNAME,what,-1);
    if val<0 then
    result := def
    else
    result := val;
  end;

begin
  if not FileExists(ininame) then
  exit;

  inifile := Tinifile.Create(ininame);

  if inifile=nil then
  exit;     //nobody home.

  Goptions.helpdir  := readstr('helpdir',Goptions.helpdir,please_load_help);
  If Goptions.helpdir='.' then
  Goptions.helpdir := '';

  Goptions.helpname := readstr('helpname',Goptions.helpname,please_load_help);
  Goptions.helpidx  := readstr('helpidx',Goptions.helpidx,please_load_help);
  Goptions.helpnumb := readstr('helpnumb',Goptions.helpnumb,please_load_help);

  top :=    readint('top',top);
  left :=   readint('left',left);
  height := readint('height',height);
  width :=  readint('width',width);

//flag a find if they want.
  pleasefind := inifile.readstring(SECNAME,'pleasefind','');
  pleaseclose := inifile.readbool(SECNAME,'close',false);

  x := readint('timer_interval',-1);

  if x>3 then
  Timer_IPC.interval := x;

  freeandnil(Inifile);

  DeleteFile(ininame);

end;

procedure Tjgowen_helpf.read_fiddle;
begin
  readini;
  fiddle_help;
end;

procedure Tjgowen_helpf.standalone_startup;
const
checked_args : boolean = false;
var
i:integer;
PreviousHandle : THandle;
TheCaption: string;
begin

  if checked_args then
  exit;

  checked_args := true;

  TheCaption := '';

  for i := 1 to ParamCount do begin
    case i of
      1: TheCaption := deblrize(ParamStr(i));
      2: ininame := ParamStr(i);
    end;
  end;

  ininame := fpgmdirize(ininame);

  if length(TheCaption)>1 then begin
//now that we have the caption supposedly, check if we are already running.
    PreviousHandle := FindWindow('Tjgowen_helpf',PCHAR(TheCaption));
    if PreviousHandle <> 0 then begin
      SetForegroundWindow(PreviousHandle);
      close;
      exit;   //this proc.
    end;
    caption := TheCaption;
    Application.Title := TheCaption;
  end;

  please_load_help := true;
  read_fiddle;

  Timer_IPC.enabled := true;

end;

{$endif}

{****************************************************************************
set-up the help and load stuff as necessary.
****************************************************************************}
procedure Tjgowen_helpf.fiddle_help;

{$ifdef STAND_ALONE}
var
x:integer;
{$endif}

  function nmset(what, val:integer):integer;
  begin
    if (val>=0) then
    result := val
    else
    result := what;
  end;

begin


  left :=   nmset(left,  Goptions.left    );
  top :=    nmset(top,   Goptions.top     );
  height := nmset(height,Goptions.height  );
  width :=  nmset(width, Goptions.width   );

  clrsearch;

{$ifdef STAND_ALONE}
  if please_load_help then begin
  please_load_help := false;
{$endif}


  thehelp     := fpgmdirize(Goptions.helpdir+Goptions.helpname);
  thecontents := fpgmdirize(Goptions.helpdir+Goptions.helpidx);
  thenumbers  := fpgmdirize(Goptions.helpdir+Goptions.helpnumb);

  loadcontents;
  loadnumbs;

{$ifdef STAND_ALONE}
  end;
{$endif}

{$ifdef STAND_ALONE}
  if pleasefind<>'' then begin
    x := JgoStrToInt(pleasefind);
    if x>0 then
    showhelp(x)
    else
    showhelp(pleasefind);

    pleasefind := '';

    pleasefocus := 2;

  end;
{$endif}

end;

procedure Tjgowen_helpf.xinit;
const
done : boolean = false;
//var
//pd : string;
begin
  if done then
  exit;

  caption := safe_format('owenhelp (%s:%s:%s/%s/%s)',
  [sTLA,sJGO_XMN,sJGO_MON,sJGO_DATE,sJGO_YEAR]);

{$ifdef STAND_ALONE}
  standalone_startup;
{$else}
  fiddle_help;
{$endif}

  done := true;

end;

{****************************************************************************
****************************************************************************}

procedure showhelp(s:string);
begin
  with jhelpf do begin
    xinit;
    if jshowing then begin
      BringToFront;
      if s<>'' then
      loadhelp(s);
    end
    else begin
      show;
      loadhelp(s);
    end;
  end;
end;

procedure showhelp(x:integer);
var
i:integer;
begin
  with jhelpf do begin
    xinit;
    for i := 0 to ListBox1.items.count-1 do begin
      if integer(ListBox1.items.objects[i]) = x then begin
        showhelp(ListBox1.items[i]);
        exit;
      end;
      showhelp('');
    end;
  end;
end;

procedure Tjgowen_helpf.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  clrsearch;
  if Key=vk_Return then begin
    key := 0;
    search;
  end;
end;

procedure Tjgowen_helpf.clrsearch;
begin
  label_search.caption := '';
end;

{****************************************************************************
****************************************************************************}

procedure Tjgowen_helpf.BitBtn_GobackClick(Sender: TObject);
begin
  try
    WebBrowser1.GoBack;
  except
    on exception do;
  end;
end;

{$ifdef STAND_ALONE}
procedure Tjgowen_helpf.focus;
begin
  Application.BringToFront;
end;
{$endif}

procedure Tjgowen_helpf.Timer_IPCTimer(Sender: TObject);
begin
{$ifdef STAND_ALONE}
  if pleaseclose then begin
    Timer_IPC.enabled := false;
    close;
    exit;
  end;

  if pleasefocus > 0 then begin
    focus;
    dec(pleasefocus);
  end;
  if FileExists(ininame) then
  read_fiddle;
{$endif}
end;

procedure Tjgowen_helpf.BitBtn_UnmarkClick(Sender: TObject);
begin
  loadhelp;
  BitBtn_Unmark.visible := false;
end;

end.
