unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button_uncurly: TButton;
    Button_curly: TButton;
    Button_datetime: TButton;
    Timer_hide: TTimer;
    Button_nbsp: TButton;
    Button_eacute: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button_uncurlyClick(Sender: TObject);
    procedure Button_curlyClick(Sender: TObject);
    procedure Button_datetimeClick(Sender: TObject);
    procedure Timer_hideTimer(Sender: TObject);
    procedure Button_nbspClick(Sender: TObject);
    procedure Button_eacuteClick(Sender: TObject);
  private
    { Private declarations }
    plzshow, plzhide : integer;
    procedure xinit;
    procedure minimize(Sender:TObject);
    procedure restore(Sender:TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses clipbrd;
{****************************************************************************
****************************************************************************}
const
plzcount = 2;

procedure hideInTaskBar;
begin
//has not effect if called in create.
  ShowWindow(Application.handle,SW_HIDE);
end;

procedure showInTaskBar;
begin
  ShowWindow(Application.handle,SW_SHOW);
end;


{****************************************************************************
****************************************************************************}


procedure TForm1.Button1Click(Sender: TObject);
begin
  clipboard.astext := '';
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  clipboard.astext := ListBox1.items[ListBox1.itemindex];
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  xinit;
end;

procedure TForm1.xinit;
const
done : bool = false;
begin
  if done then
  exit;

  done := true;

  caption := 'ml c:\gregor\mydelphi\chrs\ch.dpr';

  left := 0;
  top := 0;

  ListBox1.itemindex := 0;

  Application.onminimize := minimize;
  Application.OnRestore  := restore;
  plzhide := plzcount;
  Timer_hide.enabled := true;

end;

{****************************************************************************
<!-- $JGO$:UNCURLY -->
<!-- $JGO$:CURLY -->
<!-- $JGO$:DATETIME -->xxx<!-- $JGO$:CLOSE -->

****************************************************************************}


procedure TForm1.Button_nbspClick(Sender: TObject);
begin
  clipboard.astext := '&nbsp;';
end;

procedure TForm1.Button_eacuteClick(Sender: TObject);
begin
  clipboard.astext := '&eacute;';
end;


procedure TForm1.Button_uncurlyClick(Sender: TObject);
begin
  clipboard.astext := '<!-- $JGO$:UNCURLY -->';
end;

procedure TForm1.Button_curlyClick(Sender: TObject);
begin
  clipboard.astext := '<!-- $JGO$:CURLY -->';
end;

procedure TForm1.Button_datetimeClick(Sender: TObject);
begin
  clipboard.astext := '<!-- $JGO$:DATETIME -->xxx<!-- $JGO$:CLOSE -->';
end;

{****************************************************************************
****************************************************************************}

procedure TForm1.minimize(Sender:TObject);
begin
  plzshow := plzcount;
  Timer_hide.enabled := true;
end;

procedure TForm1.restore(Sender:TObject);
begin
  plzhide := plzcount;
  Timer_hide.enabled := true;
end;

procedure TForm1.Timer_hideTimer(Sender: TObject);
begin
  if plzshow>0 then begin
    dec(plzshow);
//    caption := 'xmas';
    showintaskbar;
  end else
  if plzhide>0 then begin
    dec(plzhide);
//    caption := 'the time is now ...';
//doesn't happen.
    hideintaskbar;
  end else
  Timer_hide.enabled := false; //off ourselves.
end;

{****************************************************************************
****************************************************************************}


end.
